Index: src/Actions/TesselationAction/ConvexEnvelopeAction.cpp
===================================================================
--- src/Actions/TesselationAction/ConvexEnvelopeAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/TesselationAction/ConvexEnvelopeAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -59,7 +59,7 @@
     //FindConvexBorder(mol, BoundaryPoints, TesselStruct, LCList, argv[argptr]);
     // TODO: Beide Funktionen sollten streams anstelle des Filenamen benutzen, besser fuer unit tests
-    FindNonConvexBorder(mol, TesselStruct, LCList, 50., params.filenameNonConvex.c_str());
+    FindNonConvexBorder(mol, TesselStruct, LCList, 50., params.filenameNonConvex.string().c_str());
     //RemoveAllBoundaryPoints(TesselStruct, mol, argv[argptr]);
-    const double volumedifference = ConvexizeNonconvexEnvelope(TesselStruct, mol, params.filenameConvex.c_str());
+    const double volumedifference = ConvexizeNonconvexEnvelope(TesselStruct, mol, params.filenameConvex.string().c_str());
     const double clustervolume = VolumeOfConvexEnvelope(TesselStruct, configuration);
     DoLog(0) && (Log() << Verbose(0) << "The tesselated volume area is " << clustervolume << " " << (configuration->GetIsAngstroem() ? "angstrom" : "atomiclength") << "^3." << endl);
@@ -95,7 +95,3 @@
   return false;
 }
-
-const string TesselationConvexEnvelopeAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/TesselationAction/ConvexEnvelopeAction.def
===================================================================
--- src/Actions/TesselationAction/ConvexEnvelopeAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/TesselationAction/ConvexEnvelopeAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
-#define paramtypes (std::string)(std::string)
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (boost::filesystem::path)(boost::filesystem::path)
 #define paramtokens ("convex-file")("nonconvex-file")
-#define paramdescriptions ("filename of the non-convex envelope")("filename of the non-convex envelope")
+#define paramdescriptions ("filename of the convex envelope")("filename of the non-convex envelope")
+#undef paramdefaults
 #define paramreferences (filenameConvex)(filenameNonConvex)
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "create the convex envelope for a molecule"
 #define SHORTFORM "x"
-#define TYPEINFO &typeid(void)
Index: src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp
===================================================================
--- src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -56,5 +56,5 @@
     start = clock();
     LCList = new LinkedCell(*Boundary, params.SphereRadius*2.);
-    Success = FindNonConvexBorder(Boundary, T, LCList, params.SphereRadius, params.filename.c_str());
+    Success = FindNonConvexBorder(Boundary, T, LCList, params.SphereRadius, params.filename.string().c_str());
     //FindDistributionOfEllipsoids(T, &LCList, N, number, params.filename.c_str());
     end = clock();
@@ -90,7 +90,3 @@
   return false;
 }
-
-const string TesselationNonConvexEnvelopeAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/TesselationAction/NonConvexEnvelopeAction.def
===================================================================
--- src/Actions/TesselationAction/NonConvexEnvelopeAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/TesselationAction/NonConvexEnvelopeAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
-#define paramtypes (double)(std::string)
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (double)(boost::filesystem::path)
 #define paramtokens ("nonconvex-envelope")("nonconvex-file")
-#define paramdescriptions ("create the non-convex envelope for a molecule")("filename of the non-convex envelope")
+#define paramdescriptions ("radius of the rolling sphere")("filename of the non-convex envelope")
+#undef paramdefaults
 #define paramreferences (SphereRadius)(filename)
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "create the non-convex envelope for a molecule"
 #define SHORTFORM "N"
-#define TYPEINFO &typeid(double)
Index: src/Actions/UndoAction.cpp
===================================================================
--- src/Actions/UndoAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
+++ src/Actions/UndoAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -0,0 +1,58 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * UndoAction.cpp
+ *
+ *  Created on: Oct 27, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "ActionHistory.hpp"
+
+#include <iostream>
+
+#include "Helpers/Assert.hpp"
+
+#include "Actions/UndoAction.hpp"
+
+// and construct the stuff
+#include "UndoAction.def"
+#include "Action_impl_pre.hpp"
+
+/** =========== define the function ====================== */
+Action::state_ptr UndoAction::performCall(){
+  std::cout << "Undo" << std::endl;
+  ActionHistory::getInstance().undoLast();
+  return Action::success;
+}
+
+Action::state_ptr UndoAction::performUndo(Action::state_ptr){
+  ASSERT(0,"Cannot undo an undo (should use redo for this");
+  return Action::success;
+}
+
+Action::state_ptr UndoAction::performRedo(Action::state_ptr){
+  ASSERT(0,"Cannot redo an undo");
+  return Action::success;
+}
+
+bool UndoAction::canUndo(){
+  return false;
+}
+
+bool UndoAction::shouldUndo(){
+  return false;
+}
+/** =========== end of function ====================== */
Index: src/Actions/UndoAction.def
===================================================================
--- src/Actions/UndoAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
+++ src/Actions/UndoAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -0,0 +1,28 @@
+/*
+ * UndoAction.def
+ *
+ *  Created on: Oct 27, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#undef paramtypes
+#undef paramreferences
+#undef paramtokens
+#undef paramdescriptions
+#undef paramdefaults
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#undef CATEGORY 
+#define MENUNAME "edit"
+#define MENUPOSITION 1
+#define ACTIONNAME Undo
+#define TOKEN "undo"
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "undo last action"
+#undef SHORTFORM
Index: src/Actions/UndoAction.hpp
===================================================================
--- src/Actions/UndoAction.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
+++ src/Actions/UndoAction.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -0,0 +1,21 @@
+/*
+ * UndoAction.hpp
+ *
+ *  Created on: Oct 27, 2010
+ *      Author: heber
+ */
+
+#ifndef UNDOACTION_HPP_
+#define UNDOACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Actions/Action.hpp"
+
+#include "UndoAction.def"
+#include "Actions/Action_impl_header.hpp"
+
+#endif /* UNDOACTION_HPP_ */
Index: src/Actions/ValueStorage.cpp
===================================================================
--- src/Actions/ValueStorage.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/ValueStorage.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -20,27 +20,318 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "ValueStorage.hpp"
 #include "Patterns/Singleton_impl.hpp"
 
+#include "Actions/OptionTrait.hpp"
+#include "Actions/OptionRegistry.hpp"
+#include "Actions/Values.hpp"
+#include "Actions/ValueStorage.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
+#include "Descriptors/MoleculeIdDescriptor.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/BoxVector.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "atom.hpp"
+#include "Box.hpp"
+#include "element.hpp"
+#include "molecule.hpp"
+#include "periodentafel.hpp"
+#include "World.hpp"
+
 ValueStorage::ValueStorage() :
-  MapOfActions_instance(MapOfActions::getInstance())
+OptionRegistry_instance(OptionRegistry::getInstance())
 {};
 
 ValueStorage::~ValueStorage() {};
 
+
+bool ValueStorage::isCurrentValuePresent(const char *name) const
+{
+  return (CurrentValueMap.find(name) != CurrentValueMap.end());
+}
+
+void ValueStorage::queryCurrentValue(const char * name, const atom * &_T)
+{
+  int atomID = -1;
+  if (typeid( atom *) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    if (CurrentValueMap.find(name) == CurrentValueMap.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    atomID = lexical_cast<int>(CurrentValueMap[name].c_str());
+    CurrentValueMap.erase(name);
+  } else if (typeid( const atom *) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    if (CurrentValueMap.find(name) == CurrentValueMap.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    atomID = lexical_cast<int>(CurrentValueMap[name].c_str());
+    CurrentValueMap.erase(name);
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+  _T = World::getInstance().getAtom(AtomById(atomID));
+}
+
+void ValueStorage::queryCurrentValue(const char * name, const element * &_T)  {
+  int Z = -1;
+  if (typeid(const element *) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    if (CurrentValueMap.find(name) == CurrentValueMap.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    Z = lexical_cast<int>(CurrentValueMap[name].c_str());
+    CurrentValueMap.erase(name);
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+  _T = World::getInstance().getPeriode()->FindElement(Z);
+}
+
+void ValueStorage::queryCurrentValue(const char * name, const molecule * &_T) {
+  int molID = -1;
+  if (typeid( const molecule *) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    if (CurrentValueMap.find(name) == CurrentValueMap.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    molID = lexical_cast<int>(CurrentValueMap[name].c_str());
+    CurrentValueMap.erase(name);
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+  _T = World::getInstance().getMolecule(MoleculeById(molID));
+}
+
+void ValueStorage::queryCurrentValue(const char * name, class Box &_T) {
+  Matrix M;
+  double tmp;
+  if (typeid( Box ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    if (CurrentValueMap.find(name) == CurrentValueMap.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    std::istringstream stream(CurrentValueMap[name]);
+    stream >> tmp;
+    M.set(0,0,tmp);
+    stream >> tmp;
+    M.set(0,1,tmp);
+    M.set(1,0,tmp);
+    stream >> tmp;
+    M.set(0,2,tmp);
+    M.set(2,0,tmp);
+    stream >> tmp;
+    M.set(1,1,tmp);
+    stream >> tmp;
+    M.set(1,2,tmp);
+    M.set(2,1,tmp);
+    stream >> tmp;
+    M.set(2,2,tmp);
+    _T = M;
+    CurrentValueMap.erase(name);
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::queryCurrentValue(const char * name, class Vector &_T) {
+  if (typeid( Vector ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    std::istringstream stream(CurrentValueMap[name]);
+    CurrentValueMap.erase(name);
+    stream >> _T[0];
+    stream >> _T[1];
+    stream >> _T[2];
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::queryCurrentValue(const char * name, class BoxVector &_T) {
+  if (typeid( BoxVector ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    std::istringstream stream(CurrentValueMap[name]);
+    CurrentValueMap.erase(name);
+    stream >> _T[0];
+    stream >> _T[1];
+    stream >> _T[2];
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::queryCurrentValue(const char * name, std::vector<const atom *>&_T)
+{
+  int atomID = -1;
+  atom *Walker = NULL;
+  if (typeid( std::vector<const atom *> ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    if (CurrentValueMap.find(name) == CurrentValueMap.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    std::istringstream stream(CurrentValueMap[name]);
+    CurrentValueMap.erase(name);
+    while (!stream.fail()) {
+      stream >> atomID >> ws;
+      Walker = World::getInstance().getAtom(AtomById(atomID));
+      if (Walker != NULL)
+        _T.push_back(Walker);
+      atomID = -1;
+      Walker = NULL;
+    }
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::queryCurrentValue(const char * name, std::vector<const element *>&_T)
+{
+  int Z = -1;
+  const element *elemental = NULL;
+  if (typeid( std::vector<const element *> ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    if (CurrentValueMap.find(name) == CurrentValueMap.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    std::istringstream stream(CurrentValueMap[name]);
+    CurrentValueMap.erase(name);
+    while (!stream.fail()) {
+      stream >> Z >> ws;
+      elemental = World::getInstance().getPeriode()->FindElement(Z);
+      if (elemental != NULL)
+        _T.push_back(elemental);
+      Z = -1;
+    }
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::queryCurrentValue(const char * name, std::vector<const molecule *>&_T)
+{
+  int molID = -1;
+  molecule *mol = NULL;
+  if (typeid( std::vector<const molecule *> ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    if (CurrentValueMap.find(name) == CurrentValueMap.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    std::istringstream stream(CurrentValueMap[name]);
+    CurrentValueMap.erase(name);
+    while (!stream.fail()) {
+      stream >> molID >> ws;
+      mol = World::getInstance().getMolecule(MoleculeById(molID));
+      if (mol != NULL)
+        _T.push_back(mol);
+      molID = -1;
+      mol = NULL;
+    }
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::queryCurrentValue(const char * name, boost::filesystem::path&_T)
+{
+  std::string tmp;
+  if (typeid( boost::filesystem::path ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    if (CurrentValueMap.find(name) == CurrentValueMap.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    std::istringstream stream(CurrentValueMap[name]);
+    CurrentValueMap.erase(name);
+    if (!stream.fail()) {
+      stream >> tmp >> ws;
+      _T = tmp;
+    }
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::setCurrentValue(const char * name, const atom * &_T)
+{
+  if (typeid( const atom *) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    std::ostringstream stream;
+    stream << _T->getId();
+    CurrentValueMap[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::setCurrentValue(const char * name, const element * &_T)
+{
+  if (typeid( const element *) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    std::ostringstream stream;
+    stream << _T->getAtomicNumber();
+    CurrentValueMap[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::setCurrentValue(const char * name, const molecule * &_T)
+{
+  if (typeid( const molecule *) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    std::ostringstream stream;
+    stream << _T->getId();
+    CurrentValueMap[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::setCurrentValue(const char * name, class Box &_T)
+{
+  const Matrix &M = _T.getM();
+  if (typeid( Box ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    std::ostringstream stream;
+    stream << M.at(0,0) << " ";
+    stream << M.at(0,1) << " ";
+    stream << M.at(0,2) << " ";
+    stream << M.at(1,1) << " ";
+    stream << M.at(1,2) << " ";
+    stream << M.at(2,2) << " ";
+    CurrentValueMap[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::setCurrentValue(const char * name, class Vector &_T)
+{
+  if (typeid( Vector ) == *(OptionRegistry_instance.getOptionByName(name)->getType())){
+    std::ostringstream stream;
+    stream << _T[0] << " ";
+    stream << _T[1] << " ";
+    stream << _T[2] << " ";
+    CurrentValueMap[name] = stream.str();
+  } else  if (typeid( BoxVector ) == *(OptionRegistry_instance.getOptionByName(name)->getType())){
+    std::ostringstream stream;
+    stream << _T[0] << " ";
+    stream << _T[1] << " ";
+    stream << _T[2] << " ";
+    CurrentValueMap[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::setCurrentValue(const char * name, std::vector<const atom *>&_T)
+{
+  if (typeid( std::vector<const atom *> ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    std::ostringstream stream;
+    for (std::vector<const atom *>::const_iterator iter = _T.begin(); iter != _T.end(); ++iter) {
+      stream << (*iter)->getId() << " ";
+    }
+    CurrentValueMap[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::setCurrentValue(const char * name, std::vector<const element *>&_T)
+{
+  if (typeid( std::vector<const element *> ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    std::ostringstream stream;
+    for (std::vector<const element *>::const_iterator iter = _T.begin(); iter != _T.end(); ++iter) {
+      stream << (*iter)->getAtomicNumber() << " ";
+    }
+    CurrentValueMap[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::setCurrentValue(const char * name, std::vector<const molecule *>&_T)
+{
+  if (typeid( std::vector<const molecule *> ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    std::ostringstream stream;
+    for (std::vector<const molecule *>::const_iterator iter = _T.begin(); iter != _T.end(); ++iter) {
+      stream << (*iter)->getId() << " ";
+    }
+    CurrentValueMap[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void ValueStorage::setCurrentValue(const char * name, boost::filesystem::path &_T)
+{
+  if (typeid( boost::filesystem::path ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {
+    std::ostringstream stream;
+    stream << _T.string();
+    CurrentValueMap[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
 const std::string ValueStorage::getCurrentValue(std::string actionname) {
-  return MapOfActions::getInstance().getCurrentValue(actionname);
-}
-
-const std::string ValueStorage::getDescription(std::string actionname) {
-  return MapOfActions::getInstance().getDescription(actionname);
-}
-
-const std::string ValueStorage::getShortForm(std::string actionname) {
-  return MapOfActions::getInstance().getShortForm(actionname);
-}
-
-const std::type_info * ValueStorage::getType(std::string actionname) {
-  return MapOfActions::getInstance().getType(actionname);
+  return CurrentValueMap[actionname];
 }
 
Index: src/Actions/ValueStorage.hpp
===================================================================
--- src/Actions/ValueStorage.hpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/ValueStorage.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -9,5 +9,32 @@
 #define VALUESTORAGE_HPP_
 
-#include "Actions/MapOfActions.hpp"
+#include <boost/filesystem.hpp>
+#include <boost/lexical_cast.hpp>
+#include <boost/program_options.hpp>
+
+#include <map>
+#include <set>
+#include <vector>
+#include <typeinfo>
+
+#include "Actions/OptionTrait.hpp"
+#include "Actions/OptionRegistry.hpp"
+#include "Exceptions/IllegalTypeException.hpp"
+#include "Exceptions/MissingValueException.hpp"
+#include "Helpers/Assert.hpp"
+#include "Patterns/Singleton.hpp"
+
+class MapOfActionsTest;
+
+class Box;
+class atom;
+class element;
+class molecule;
+class Vector;
+
+namespace po = boost::program_options;
+
+using boost::lexical_cast;
+
 #include "Patterns/Singleton.hpp"
 
@@ -21,4 +48,17 @@
 
 public:
+
+  bool isCurrentValuePresent(const char *name) const;
+  void queryCurrentValue(const char * name, const atom * &_T);
+  void queryCurrentValue(const char * name, const element * &_T);
+  void queryCurrentValue(const char * name, const molecule * &_T);
+  void queryCurrentValue(const char * name, class Box &_T);
+  void queryCurrentValue(const char * name, class Vector &_T);
+  void queryCurrentValue(const char * name, class BoxVector &_T);
+  void queryCurrentValue(const char * name, std::vector<const atom *>&_T);
+  void queryCurrentValue(const char * name, std::vector<const element *>&_T);
+  void queryCurrentValue(const char * name, std::vector<const molecule *>&_T);
+  void queryCurrentValue(const char * name, boost::filesystem::path&_T);
+
   /** Gets a value from the storage
    * If the value is not present, an ASSERT is thrown unless optional is set to true.
@@ -27,12 +67,39 @@
    * \return true - value present, false - value not present (only given when optional set to true)
    */
-  template <typename T> bool queryCurrentValue(const char *name, T &_T, const bool optional = false) {
-    if (optional) {
-      if (!MapOfActions_instance.isCurrentValuePresent(name))
-        return false;
-    }
-    MapOfActions_instance.queryCurrentValue(name, _T);
-    return true;
+  template<typename T> void queryCurrentValue(const char * name, T &_T)
+  {
+    if (typeid( T ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) { // constructor of type_info is private, hence can only store by ref or ptr
+      if (CurrentValueMap.find(name) == CurrentValueMap.end())
+        throw MissingValueException(__FILE__, __LINE__);
+      _T = lexical_cast<T>(CurrentValueMap[name].c_str());
+      CurrentValueMap.erase(name);
+    } else
+      throw IllegalTypeException(__FILE__,__LINE__);
   }
+  template<typename T> void queryCurrentValue(const char * name, std::vector<T> &_T)
+  {
+    T temp;
+    if (typeid( std::vector<T> ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) { // constructor of type_info is private, hence can only store by ref or ptr
+      if (CurrentValueMap.find(name) == CurrentValueMap.end())
+        throw MissingValueException(__FILE__, __LINE__);
+      std::istringstream stream(CurrentValueMap[name]);
+      CurrentValueMap.erase(name);
+      while (!stream.fail()) {
+        stream >> temp >> std::ws;
+        _T.push_back(temp);
+      }
+    } else
+      throw IllegalTypeException(__FILE__,__LINE__);
+  }
+
+  void setCurrentValue(const char * name, const atom * &_T);
+  void setCurrentValue(const char * name, const element * &_T);
+  void setCurrentValue(const char * name, const molecule * &_T);
+  void setCurrentValue(const char * name, class Box &_T);
+  void setCurrentValue(const char * name, class Vector &_T);
+  void setCurrentValue(const char * name, std::vector<const atom *>&_T);
+  void setCurrentValue(const char * name, std::vector<const element *>&_T);
+  void setCurrentValue(const char * name, std::vector<const molecule *>&_T);
+  void setCurrentValue(const char * name, boost::filesystem::path&_T);
 
   /** Sets a value in the storage.
@@ -40,16 +107,31 @@
    * \param _T value
    */
-  template <typename T> void setCurrentValue(const char *name, T &_T) {
-    MapOfActions_instance.setCurrentValue(name, _T);
+  template<class T> void setCurrentValue(const char * name, T &_T)
+  {
+    std::ostringstream stream;
+    if (typeid( T ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {  // constructor of type_info is private, hence can only store by ref or ptr
+      stream << _T;
+      CurrentValueMap[name] = stream.str();
+    } else
+      throw IllegalTypeException(__FILE__,__LINE__);
+  }
+  /** Sets a value in the storage.
+   * \param name key of value
+   * \param _T value
+   */
+  template<class T> void setCurrentValue(const char * name, std::vector<T> &_T)
+  {
+    std::ostringstream stream;
+    if (typeid( std::vector<T> ) == *(OptionRegistry_instance.getOptionByName(name)->getType())) {  // constructor of type_info is private, hence can only store by ref or ptr
+      std::ostringstream stream;
+      for (typename std::vector<T>::const_iterator iter = _T.begin(); iter != _T.end(); ++iter) {
+        stream << (*iter) << " ";
+      }
+      CurrentValueMap[name] = stream.str();
+    } else
+      throw IllegalTypeException(__FILE__,__LINE__);
   }
 
-  /** Obtain a descriptive text for a given key.
-   * \param actionname key
-   * \return text describing the key's contents
-   */
   const std::string getCurrentValue(std::string actionname);
-  const std::string getDescription(std::string actionname);
-  const std::string getShortForm(std::string actionname);
-  const std::type_info * getType(std::string actionname);
 
 protected:
@@ -57,5 +139,7 @@
   ~ValueStorage();
 
-  MapOfActions &MapOfActions_instance;
+  std::map<std::string, std::string> CurrentValueMap;
+
+  OptionRegistry &OptionRegistry_instance;
 };
 
Index: src/Actions/WorldAction/AddEmptyBoundaryAction.cpp
===================================================================
--- src/Actions/WorldAction/AddEmptyBoundaryAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/WorldAction/AddEmptyBoundaryAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -98,7 +98,3 @@
   return false;
 }
-
-const string WorldAddEmptyBoundaryAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/WorldAction/AddEmptyBoundaryAction.def
===================================================================
--- src/Actions/WorldAction/AddEmptyBoundaryAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/WorldAction/AddEmptyBoundaryAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -12,8 +12,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #define paramtypes (Vector)
 #define paramtokens ("boundary")
-#define paramdescriptions ("change box to add an empty boundary around all atoms")
+#define paramdescriptions ("desired minimum distance to boundary for each axis over all atoms")
+#undef paramdefaults
 #define paramreferences (boundary)
 
@@ -30,6 +31,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "change box to add an empty boundary around all atoms"
 #define SHORTFORM "c"
-#define TYPEINFO &typeid(VectorValue)
Index: src/Actions/WorldAction/BoundInBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/BoundInBoxAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/WorldAction/BoundInBoxAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -69,7 +69,3 @@
   return false;
 }
-
-const string WorldBoundInBoxAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/WorldAction/BoundInBoxAction.def
===================================================================
--- src/Actions/WorldAction/BoundInBoxAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/WorldAction/BoundInBoxAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
 #undef paramdescriptions
+#undef paramdefaults
 #undef paramreferences
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "bound all atoms in the domain"
 #undef SHORTFORM
-#define TYPEINFO &typeid(void)
Index: src/Actions/WorldAction/CenterInBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/CenterInBoxAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/WorldAction/CenterInBoxAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -71,7 +71,3 @@
   return false;
 }
-
-const string WorldCenterInBoxAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/WorldAction/CenterInBoxAction.def
===================================================================
--- src/Actions/WorldAction/CenterInBoxAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/WorldAction/CenterInBoxAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -12,8 +12,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #define paramtypes (Box)
 #define paramtokens ("center-in-box")
-#define paramdescriptions ("center all atoms in the domain")
+#define paramdescriptions ("symmetric matrix of new domain")
+#undef paramdefaults
 #define paramreferences (cell_size)
 
@@ -30,6 +31,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "center all atoms in the domain"
 #define SHORTFORM "b"
-#define TYPEINFO &typeid(BoxValue)
